using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserWallet;
namespace CMSMicroservice.Protobuf.Validator.UserWallet;

public class GetUserWalletRequestValidator : AbstractValidator<GetUserWalletRequest>
{
    public GetUserWalletRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetUserWalletRequest>.CreateWithOptions((GetUserWalletRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
